/*
 * Heat1d_e_4.java -- Canvas ѤС
 * 1998ǯ1120
 *
 * ѥ: javac Heat1d_e_4.java
 * ¹:       appletviewer Heat1d_e_4.java
 *
 * <APPLET code="Heat1d_e_4.class" width=500 height=500></APPLET>
 */

import java.applet.*;
import java.awt.*;

public class Heat1d_e_4 extends Applet {

  private int N = 20;
  private double lambda = 0.5;
  private double Tmax = 0.5;
  // 桼ȤΥ󥿡ե (ѥ᡼)
  private Label labelLambda, labelN, labelTmax;
  private TextField inputLambda, inputN, inputTmax;
  private Button startB;
  // ʬˡˤǮߥ졼
  private HeatCanvas c1;

  //  (ѿѰդȺɸϤνʤ)
  public void init() {
    //
    setLayout(null);
    // =(/h^2) Ϥ뤿Υƥȡե
    labelLambda = new Label("lambda (should be <= 1/2)");
    add(labelLambda);
    labelLambda.reshape(100, 10, 200, 30);
    inputLambda = new TextField("" + lambda);
    add(inputLambda);
    inputLambda.reshape(300, 10, 100, 30);
    // N (֤ʬ) Ϥ뤿Υƥȡե
    labelN = new Label("N");
    add(labelN);
    labelN.reshape(100, 45, 200, 30);
    inputN = new TextField("" + N);
    add(inputN);
    inputN.reshape(300, 45, 100, 30);
    // Tmax (׻) Ϥ뤿Υƥȡե
    labelTmax = new Label("Tmax");
    add(labelTmax);
    labelTmax.reshape(100, 80, 200, 30);
    inputTmax = new TextField("" + Tmax);
    add(inputTmax);
    inputTmax.reshape(300, 80, 100, 30);
    // Ʒ׻ܥ
    startB = new Button("Restart");
    add(startB);
    startB.reshape(420, 60, 50, 30);
    // ǵǮץХ
    c1 = new HeatCanvas();
    add(c1);
    c1.reshape(50, 100, 400, 400);
    c1.compute(lambda, N, Tmax);
  }

  // ܥ򲡤줿顢ƥȡեɤƤɤ߼äơ
  public boolean action(Event evt, Object what) {
    if (evt.target == startB) {
      String str1 = inputLambda.getText();
      String str2 = inputN.getText();
      String str3 = inputTmax.getText();
      lambda = Double.valueOf(str1).doubleValue();
      N = Integer.parseInt(str2);
      Tmax = Double.valueOf(str3).doubleValue();
      c1.compute(lambda, N, Tmax);
    }
    return true;
  }

}

// HeatCanvas.java
// 1998ǯ1120

class HeatCanvas extends Canvas {

  static final boolean DEBUG = false; // true;
  private static final String message = "1D Heat Equation";
  // ˼äƴŪʥѥ᡼
  //   N:      ֤ʬ
  //   Tmax:   ǽ
  //   lambda: =/h^2
  private int N;
  private double Tmax, lambda;
  // ɸϤѴΤΥѥ᡼
  private int CanvasX = 400, CanvasY = 400;
  private double ratiox, ratioy, X0, Y0;
  //
  private HeatCanvas c1;

  // 󥹥ȥ饯
  public HeatCanvas() {
    super();
    space(-0.1, -0.1, 1.1, 1.1);
  }
  public HeatCanvas(int cx, int cy) {
    super();
    CanvasX = cx; CanvasY = cy;
    space(-0.1, -0.1, 1.1, 1.1);
  }

  public void compute(double lambda, int N, double Tmax) {
    this.lambda = lambda;
    this.N = N;
    this.Tmax = Tmax;
    repaint();
  }

  // 
  private double f(double x) {
    if (x <= 0.5)
      return x;
    else
      return 1.0 - x;
  }
  // ɸѴν
  private void space(double x0, double y0, double x1, double y1) {
    X0 = x0; Y0 = y0;
    ratiox = CanvasX / (x1 - x0);
    ratioy = CanvasY / (y1 - y0);
  }
  // 桼ɸ (ɺɸ) 򥦥ɥɸ (ǥХɸ)
  private int wx(double x) {
    return (int)(ratiox * (x - X0));
  }
  // 桼ɸ (ɺɸ) 򥦥ɥɸ (ǥХɸ)
  private int wy(double y) {
    return CanvasY - (int)(ratioy * (y - Y0));
  }
  // x[], y[] Ƥ򥰥դˤ
  private void drawGaph(Graphics g, double x[], double u[]) {
    for (int i= 0; i < N; i++)
      g.drawLine(wx(x[i]), wy(u[i]), wx(x[i + 1]), wy(u[i + 1]));
  }

  public void paint(Graphics g) {

    double h = 1.0 / N;
    double tau = lambda * h * h;
    double dt = 0.01;
    int Jmax = (int) (Tmax / tau);
    int skip = (int) (dt / tau + 0.5);
    double [] u, unext, x;

    // ٥ȥݤ
    x = new double[N+1];
    u = new double[N+1];
    unext = new double[N+1];
    for (int i = 0; i <= N; i++)
      x[i] = i * h;

    // Ϥޤ̣ʤ
    g.setColor(Color.pink);
    g.fillOval(10, 10, 330, 60);
    g.setColor(Color.red);
    for (int i=0; i<4;i++) 
      g.drawOval(10-i, 10-i, 330+2*i, 60+2*i);

    // ȥɽ
    g.setColor(Color.black);
    g.setFont(new Font("Helvetica", Font.BOLD, 24));
    g.drawString(message, 40, 50);

    // ͤ׻
    for (int i = 0; i <= N; i++)
      u[i] = f(i * h);

    // ͤΥդ
    drawGaph(g, x, u);

    // ֤˴ؤ롼
    for (int j = 1; j <= Jmax; j++) {
      int i;
      for (i = 1; i < N; i++)
        unext[i] = (1 - 2 * lambda) * u[i]
		+ lambda * (u[i-1] + u[i+1]);
      for (i = 1; i < N; i++)
        u[i] = unext[i];
      u[0] = 0; u[N] = 0;

      if (DEBUG)
        for (i = 0; i <= N; i++)
          System.out.println("u[" + i + "]=" + u[i]);
      // Ŭʴֳ (dt=0.01) ǥդ
      if (j % skip == 0)
        drawGaph(g, x, u);
    }
  }
}
