// HeatCanvas.java

import java.awt.*;

public class HeatCanvas extends Canvas {

  static final boolean DEBUG = false; // true;
  private static final String message = "1D Heat Equation";
  // ˼äƴŪʥѥ᡼
  //   N:      ֤ʬ
  //   Tmax:   ǽ
  //   lambda: =/h^2
  private int N;
  private double Tmax, lambda;
  // ɸϤѴΤΥѥ᡼
  private int CanvasX = 400, CanvasY = 400;
  private double ratiox, ratioy, X0, Y0;
  //
  private HeatCanvas c1;

  // 󥹥ȥ饯
  public HeatCanvas() {
    super();
    space(-0.1, -0.1, 1.1, 1.1);
  }
  public HeatCanvas(int cx, int cy) {
    super();
    CanvasX = cx; CanvasY = cy;
    space(-0.1, -0.1, 1.1, 1.1);
  }

  public void compute(double lambda, int N, double Tmax) {
    this.lambda = lambda;
    this.N = N;
    this.Tmax = Tmax;
    repaint();
  }

  // 
  private double f(double x) {
    if (x <= 0.5)
      return x;
    else
      return 1.0 - x;
  }
  // ɸѴν
  private void space(double x0, double y0, double x1, double y1) {
    X0 = x0; Y0 = y0;
    ratiox = CanvasX / (x1 - x0);
    ratioy = CanvasY / (y1 - y0);
  }
  // 桼ɸ (ɺɸ) 򥦥ɥɸ (ǥХɸ)
  private int wx(double x) {
    return (int)(ratiox * (x - X0));
  }
  // 桼ɸ (ɺɸ) 򥦥ɥɸ (ǥХɸ)
  private int wy(double y) {
    return CanvasY - (int)(ratioy * (y - Y0));
  }
  // x[], y[] Ƥ򥰥դˤ
  private void drawGaph(Graphics g, double x[], double u[]) {
    for (int i= 0; i < N; i++)
      g.drawLine(wx(x[i]), wy(u[i]), wx(x[i + 1]), wy(u[i + 1]));
  }

  public void paint(Graphics g) {

    double h = 1.0 / N;
    double tau = lambda * h * h;
    double dt = 0.01;
    int Jmax = (int) (Tmax / tau);
    int skip = (int) (dt / tau + 0.5);
    double [] u, unext, x;

    // ٥ȥݤ
    x = new double[N+1];
    u = new double[N+1];
    unext = new double[N+1];
    for (int i = 0; i <= N; i++)
      x[i] = i * h;

    // Ϥޤ̣ʤ
    g.setColor(Color.pink);
    g.fillOval(10, 10, 330, 60);
    g.setColor(Color.red);
    for (int i=0; i<4;i++) 
      g.drawOval(10-i, 10-i, 330+2*i, 60+2*i);

    // ȥɽ
    g.setColor(Color.black);
    g.setFont(new Font("Helvetica", Font.BOLD, 24));
    g.drawString(message, 40, 50);

    // ͤ׻
    for (int i = 0; i <= N; i++)
      u[i] = f(i * h);

    // ͤΥդ
    drawGaph(g, x, u);

    // ֤˴ؤ롼
    for (int j = 1; j <= Jmax; j++) {
      int i;
      for (i = 1; i < N; i++)
        unext[i] = (1 - 2 * lambda) * u[i]
		+ lambda * (u[i-1] + u[i+1]);
      for (i = 1; i < N; i++)
        u[i] = unext[i];
      u[0] = 0; u[N] = 0;

      if (DEBUG)
        for (i = 0; i <= N; i++)
          System.out.println("u[" + i + "]=" + u[i]);
      // Ŭʴֳ (dt=0.01) ǥդ
      if (j % skip == 0)
        drawGaph(g, x, u);
    }
  }
}
