/*
 * NewHeat1Dv2.java
 *   version 2.0: ׻åɤѰդ
 */

import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class NewHeat1Dv2 extends Frame implements Runnable {
        static final int WX = 500, WY = 500;
        Thread th = null;
        Image im = null;
        Graphics bg = null;
        int i, n = -1, nMax;
        int N = 200;
        double lambda = 0.5;
        double Tmax = 1.0;
        double dt = 0.01;
        double h, tau;
        int skip;
        double [] x, u, newu;
        double ratiox, ratioy, X0, Y0;
        public NewHeat1Dv2() {
                this.setSize(WX, WY);
                this.addWindowListener(new WindowAdapter() {
                        public void windowClosing(WindowEvent ev) {
                                System.exit(0);
                        }
                });
                this.setVisible(true);
                space(-0.1, -0.1, 1.1, 1.1);
                // 
                h = 1.0 / N;
                tau = lambda * h * h;
                //
                skip = (int)Math.rint(dt / tau);
                nMax = (int)Math.ceil(Tmax / tau);
                // ٥ȥ3Ѱդ
                x = new double [N+1];
                u = new double [N+1];
                newu = new double [N+1];
                // ͤ׻
                for (int i = 0; i <= N; i++)
                        x[i] = i * h;
                // Υƥå׿ --- ޤ׻ƤʤΤ(-1)ƥå
                n = -1;
                // ׻åɤ򳫻Ϥ
                this.start();
        }
        public void start() {
                if (th == null) {
                        th = new Thread(this);
                        th.start();
                }
        }
        public void stop() {
                if (th != null) {
                        th = null;
                }
        }
        public static void main(String[] args) {
                new NewHeat1Dv2();
        }
        // ɸѴλȤ
        private void space(double x0, double y0, double x1, double y1) {
                X0 = x0; Y0 = y0;
                ratiox = WX / (x1 - x0);
                ratioy = WY / (y1 - y0);
        }
        // xɸ桼ɸ饦ɥɸ
        private int wx(double x) {
                return (int)Math.rint(ratiox * (x - X0));
        }
        // yɸ桼ɸ饦ɥɸ
        private int wy(double y) {
                return WY - (int)Math.rint(ratioy * (y - Y0));
        }
        // ǡ
        private double f(double x) {
                if (x <= 0.5)
                        return x;
                else
                        return 1.0 - x;
        }
        // ߤ u[] 򥰥ղ
        private void drawGraph() {
                if (bg == null)
                        repaint();
                for (int i = 0; i < N; i++)
                        bg.drawLine(wx(x[i]), wy(u[i]), wx(x[i+1]), wy(u[i+1]));
        }
        // ֥Хåե󥰤
        public void paint(Graphics g) {
                if (im == null) {
                        // createImage() ϥ󥹥ȥ饯ǤϻȤΥߥ󥰤Ǥ뤷ʤȤ
                        im = this.createImage(this.getWidth(), this.getHeight());
                        bg = im.getGraphics();
                }
                g.drawImage(im, 0, 0, this);
        }
        // ׻å
        public void run() {
                while (th != null) {
                        if (n == -1) {
                                for (i = 0; i <= N; i++)
                                        u[i] = f(i * h);
                                n++;
                                drawGraph();
                                repaint();
                                try {
                                        Thread.sleep(10);
                                } catch (Exception ex) {
                                        ex.printStackTrace();
                                }
                        }
                        else if (n < nMax) {
                                do {
                                        for (i = 1; i < N; i++)
                                                newu[i] = (1 - 2 * lambda) * u[i] + lambda * (u[i + 1] + u[i - 1]);
                                        for (i = 1; i < N; i++)
                                                u[i] = newu[i];
                                        u[0] = 0.0;
                                        u[N] = 0.0;
                                        n++;
                                } while (n % skip != 0);
                                drawGraph();
                                repaint();
                                try {
                                        Thread.sleep(10);
                                } catch (Exception ex) {
                                        ex.printStackTrace();
                                }
                                // System.out.println(""+ n * tau);
                        }
                }
        }
}
