/*
 * NewHeat1Dv3.java
 *   version 2.0: ׻åɤѰդ
 *   version 3.0: ܥ󡢥ƥȡեɤʤɤѰդƺƷ׻ǽˤ
 *   version 4.0: (ͽ) ˡΰ̲
 *   version 5.0: (ͽ) μ䤹
 */

import java.awt.Button;
import java.awt.Color;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Label;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class NewHeat1Dv3 extends Frame implements Runnable,ActionListener {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    /**
     * 
     */
    static final int ImgX = 500, ImgY = 500;
    static final int WinX = ImgX + 200, WinY = ImgY;
    Thread th = null;
    Image im = null;
    Graphics bg = null;
    int i, n = -1, nMax;
    int N;
    double lambda, Tmax, dt, theta;
    double h, tau;
    int skip;
    double [] x, u, newu;
    double ratiox, ratioy, X0, Y0;
    private String[] labelStr={"N", "lamba", "Tmax", "dt", "theta"};
    private Label[] label;
    private String[] txStr={"100", "0.5", "1.0", "0.01", "0.5"};
    private TextField[] tf;
    private String[] btStr = {"Start", "End"};
    private Button[] bt;
    private void readParameters() {
        N = Integer.parseInt(tf[0].getText());
        lambda = Double.valueOf(tf[1].getText()).doubleValue();
        Tmax = Double.valueOf(tf[2].getText()).doubleValue();
        dt = Double.valueOf(tf[3].getText()).doubleValue();
        theta = Double.valueOf(tf[4].getText()).doubleValue();
    }
    public NewHeat1Dv3() {
        this.setSize(WinX, WinY);
        this.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent ev) {
                    System.exit(0);
                }
            });
        setLayout(null);
        bt = new Button[btStr.length];
        for (int i = 0; i < bt.length; i++) {
            bt[i] = new Button(btStr[i]);
            bt[i].addActionListener(this);
            bt[i].setBounds(ImgX, (i+2)*20, (WinX - ImgX)/2, 20);
            add(bt[i]);
        }
        label = new Label[labelStr.length];
        tf = new TextField[txStr.length];
        for (int i = 0; i < labelStr.length; i++) {
            label[i] = new Label(labelStr[i]);
            tf[i] = new TextField(txStr[i]);
            label[i].setBounds(ImgX, (i+bt.length+2)*20, (WinX - ImgX) / 3, 20);
            tf[i].setBounds(ImgX + (WinX-ImgX)/3, (i+bt.length+2)*20, (WinX-ImgX)/2, 20);
            add(label[i]);
            add(tf[i]);
        }
        this.setVisible(true);
        bt[0].setEnabled(false);
        space(-0.1, -0.1, 1.1, 1.1);
        // ׻Ϥν
        initcomputation();
        // ׻åɤ򳫻Ϥ
        this.start();
    }
    public void start() {
        if (th == null) {
            th = new Thread(this);
            th.start();
        }
    }
    public void stop() {
        if (th != null) {
            th = null;
        }
    }
    public static void main(String[] args) {
        new NewHeat1Dv3();
    }
    // ɸѴλȤ
    private void space(double x0, double y0, double x1, double y1) {
        X0 = x0; Y0 = y0;
        ratiox = ImgX / (x1 - x0);
        ratioy = ImgY / (y1 - y0);
    }
    // xɸ桼ɸ饦ɥɸ
    private int wx(double x) {
        return (int)Math.rint(ratiox * (x - X0));
    }
    // yɸ桼ɸ饦ɥɸ
    private int wy(double y) {
        return ImgY - (int)Math.rint(ratioy * (y - Y0));
    }
    // ǡ
    private double f(double x) {
        if (x <= 0.5)
            return x;
        else
            return 1.0 - x;
    }
    // ߤ u[] 򥰥ղ
    private void drawGraph() {
        if (bg == null)
            repaint();
        for (int i = 0; i < N; i++)
            bg.drawLine(wx(x[i]), wy(u[i]), wx(x[i+1]), wy(u[i+1]));
    }
    // ֥Хåե󥰤
    public void paint(Graphics g) {
        if (im == null) {
            // createImage() ϥ󥹥ȥ饯ǤϻȤΥߥ󥰤Ǥ뤷ʤȤ
            im = this.createImage(this.getWidth(), this.getHeight());
            bg = im.getGraphics();
        }
        g.drawImage(im, 0, 0, this);
    }
    private void initcomputation() {
        // ѥ᡼ɤ
        readParameters();
        // 
        h = 1.0 / N;
        tau = lambda * h * h;
        //
        skip = (int)Math.rint(dt / tau);
        if (skip <= 0) skip = 1;
        nMax = (int)Math.ceil(Tmax / tau);
        // ٥ȥ3Ѱդ
        x = new double [N+1];
        u = new double [N+1];
        newu = new double [N+1];
        //
        n = -1;
        System.out.println("init");
    }
    // ׻å
    public void run() {
        while (th != null) {
            if (n == -1) {
                // ͤ׻
                for (int i = 0; i <= N; i++)
                    x[i] = i * h;
                for (i = 0; i <= N; i++)
                    u[i] = f(i * h);
                n++;
                repaint();
                bg.setColor(Color.white);
                bg.fillRect(0, 0, ImgX, ImgY);
                bg.setColor(Color.black);
                drawGraph();
                repaint();
                try {
                    Thread.sleep(10);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
            else if (n < nMax) {
                do {
                    for (i = 1; i < N; i++)
                        newu[i] = (1 - 2 * lambda) * u[i] + lambda * (u[i + 1] + u[i - 1]);
                    for (i = 1; i < N; i++)
                        u[i] = newu[i];
                    u[0] = 0.0;
                    u[N] = 0.0;
                    n++;
                } while (n % skip != 0);
                drawGraph();
                repaint();
                try {
                    Thread.sleep(10);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
                // System.out.println(""+ n * tau);
            }
            Thread.yield();
        }
    }
    public void actionPerformed(ActionEvent e) {
        // TODO ư줿᥽åɡ
        if (e.getSource() == bt[0]) {
            bt[0].setEnabled(false);
            bt[1].requestFocus();
            bt[1].setEnabled(true);
            initcomputation();
            start();
        }
        if (e.getSource() == bt[1]) {
            bt[0].setEnabled(true);
            bt[0].requestFocus();
            bt[1].setEnabled(false);
            stop();
        }
    }
}
